Loading...
Searching...
No Matches
juce::AudioParameterFloat Class Reference

## Detailed Description

A subclass of AudioProcessorParameter that provides an easy way to create a parameter which maps onto a given NormalisableRange.

See also
  AudioParameterInt, AudioParameterBool, AudioParameterChoice

The documentation for this class was generated from the following file:

- juce_audio_processors_headless/utilities/juce_AudioParameterFloat.h

Inheritance diagram for juce::AudioParameterFloat:

## Public Member Functions

| AudioParameterFloat (const ParameterID &parameterID, const String &parameterName, NormalisableRange< float > normalisableRange, float defaultValue, const AudioParameterFloatAttributes &attributes={})
| Creates a AudioParameterFloat with the specified parameters.

AudioParameterFloat (const ParameterID &parameterID, const String &parameterName, NormalisableRange< float > normalisableRange, float defaultValue, const String &parameterLabel, Category parameterCategory=AudioProcessorParameter::genericParameter, std::function< String(float value, int maximumStringLength)> stringFromValue=nullptr, std::function< float(const String &text)> valueFromString=nullptr)

| Creates a AudioParameterFloat with the specified parameters.
| AudioParameterFloat (const ParameterID &parameterID, const String &parameterName, float minValue, float maxValue, float defaultValue)
| Creates a AudioParameterFloat with an ID, name, and range.
| ~AudioParameterFloat () override
| Destructor.
float | get () const noexcept
| Returns the parameter's current value.
| operator float () const noexcept
| Returns the parameter's current value.
AudioParameterFloat & | operator= (float newValue)
| Changes the parameter's current value.
const NormalisableRange< float > & | getNormalisableRange () const override
| Returns the range of values that the parameter can take.
Public Member Functions inherited from juce::RangedAudioParameter
int | getNumSteps () const override
| Returns the number of steps for this parameter based on the normalisable range's interval.
float | convertTo0to1 (float v) const noexcept
| Normalises and snaps a value based on the normalisable range.
float | convertFrom0to1 (float v) const noexcept
| Denormalises and snaps a value based on the normalisable range.
| AudioProcessorParameterWithID (const ParameterID &parameterID, const String &parameterName, const AudioProcessorParameterWithIDAttributes &attributes={})
| The creation of this object requires providing a name and ID which will be constant for its lifetime.
| AudioProcessorParameterWithID (const ParameterID &parameterID, const String &parameterName, const String &parameterLabel, Category parameterCategory=AudioProcessorParameter::genericParameter)
| The creation of this object requires providing a name and ID which will be constant for its lifetime.
Public Member Functions inherited from juce::AudioProcessorParameterWithID
| AudioProcessorParameterWithID (const ParameterID &parameterID, const String &parameterName, const AudioProcessorParameterWithIDAttributes &attributes={})
| The creation of this object requires providing a name and ID which will be constant for its lifetime.
| AudioProcessorParameterWithID (const ParameterID &parameterID, const String &parameterName, const String &parameterLabel, Category parameterCategory=AudioProcessorParameter::genericParameter)
| The creation of this object requires providing a name and ID which will be constant for its lifetime.
String | getName (int) const override
| Returns the name to display for this parameter, which should be made to fit within the given string length.
String | getLabel () const override
| Some parameters may be able to return a label string for their units.
Category | getCategory () const override
| Returns the parameter's category.
String | getParameterID () const override
| Returns an ID that is unique to this parameter.
bool | isMetaParameter () const override
| Should return true if this parameter is a "meta" parameter.
bool | isAutomatable () const override
| Returns true if the host can automate this parameter.
bool | isOrientationInverted () const override
| This can be overridden to tell the host that this parameter operates in the reverse direction.
Public Member Functions inherited from juce::HostedAudioProcessorParameter
| AudioProcessorParameter () noexcept=default
| AudioProcessorParameter (int versionHint)
| The version hint supplied to this constructor is used in Audio Unit plugins to aid ordering parameter identifiers when JUCE_FORCE_USE_LEGACY_PARAM_IDS is not enabled.
Public Member Functions inherited from juce::AudioProcessorParameter
| AudioProcessorParameter () noexcept=default
| AudioProcessorParameter (int versionHint)
| The version hint supplied to this constructor is used in Audio Unit plugins to aid ordering parameter identifiers when JUCE_FORCE_USE_LEGACY_PARAM_IDS is not enabled.
virtual | ~AudioProcessorParameter ()
| Destructor.
void | setValueNotifyingHost (float newValue)
| A processor should call this when it needs to change one of its parameters.
void | beginChangeGesture ()
| Sends a signal to the host to tell it that the user is about to start changing this parameter.
void | endChangeGesture ()
| Tells the host that the user has finished changing this parameter.
virtual bool | isDiscrete () const
| Returns whether the parameter uses discrete values, based on the result of getNumSteps, or allows the host to select values continuously.
virtual bool | isBoolean () const
| Returns whether the parameter represents a boolean switch, typically with "On" and "Off" states.
int | getParameterIndex () const noexcept
| Returns the index of this parameter in its parent processor's parameter list.
void | setParameterIndex (int) noexcept
virtual String | getCurrentValueAsText () const
| Returns the current value of the parameter as a String.
virtual StringArray | getAllValueStrings () const
| Returns the set of strings which represent the possible states a parameter can be in.
int | getVersionHint () const
void | setOwner (Listener *listener) noexcept
void | addListener (Listener *newListener)
| Registers a listener to receive events when the parameter's state changes.
void | removeListener (Listener *listener)
| Removes a previously registered parameter listener.
void | sendValueChangedMessageToListeners (float newValue)

## Public Attributes

NormalisableRange< float > | range
| Provides access to the parameter's range.
Public Attributes inherited from juce::AudioProcessorParameterWithID
const String | paramID
| Provides access to the parameter's ID string.
const String | name
| Provides access to the parameter's name.
const String | label
| Provides access to the parameter's label.
const Category | category
| Provides access to the parameter's category.

## Protected Member Functions

virtual void | valueChanged (float newValue)
| Override this method if you are interested in receiving callbacks when the parameter value changes.

## Additional Inherited Members

Public Types inherited from juce::AudioProcessorParameter
enum | Category { genericParameter = (0 << 16) | 0 , inputGain = (1 << 16) | 0 , outputGain = (1 << 16) | 1 , inputMeter = (2 << 16) | 0 , outputMeter = (2 << 16) | 1 , compressorLimiterGainReductionMeter = (2 << 16) | 2 , expanderGateGainReductionMeter = (2 << 16) | 3 , analysisMeter = (2 << 16) | 4 , otherMeter = (2 << 16) | 5 }
Static Public Member Functions inherited from juce::AudioProcessorParameter
static int | getDefaultNumParameterSteps () noexcept
| Returns the default number of steps for a parameter.

## Constructors and Destructors

## AudioParameterFloat() [1/3]

juce::AudioParameterFloat::AudioParameterFloat | ( | const ParameterID & | parameterID,
|  | const String & | parameterName,
|  | NormalisableRange< float > | normalisableRange,
|  | float | defaultValue,
|  | const AudioParameterFloatAttributes & | attributes = {} )

Creates a AudioParameterFloat with the specified parameters.

Note that the attributes argument is optional and only needs to be supplied if you want to change options from their default values.

Example usage:

auto attributes = AudioParameterFloatAttributes().withStringFromValueFunction ([] (auto x, auto) { return String (x * 100); })
.withLabel ("%");
auto param = std::make_unique<AudioParameterFloat> ("paramID", "Parameter Name", NormalisableRange<float>(), 0.5f, attributes);
juce::AudioParameterFloatAttributes
Properties of an AudioParameterFloat.
Definition juce_AudioParameterFloat.h:44
juce::NormalisableRange
Represents a mapping between an arbitrary range of values and a normalised 0->1 range.
Definition juce_NormalisableRange.h:52
juce::RangedAudioParameterAttributes::withStringFromValueFunction
auto withStringFromValueFunction(StringFromValue x) const
An optional lambda function that converts a non-normalised value to a string with a maximum length.
Definition juce_RangedAudioParameter.h:63
juce::String
The JUCE String class!
Definition juce_String.h:67
x
float x
Definition juce_UnityPluginInterface.h:197

Parameters

  parameterID | The parameter ID to use
  parameterName | The parameter name to use
  normalisableRange | The NormalisableRange to use
  defaultValue | The non-normalised default value
  attributes | Optional characteristics

Referenced by AudioParameterFloat(), operator=(), and valueChanged().

## AudioParameterFloat() [2/3]

juce::AudioParameterFloat::AudioParameterFloat | ( | const ParameterID & | parameterID,
|  | const String & | parameterName,
|  | NormalisableRange< float > | normalisableRange,
|  | float | defaultValue,
|  | const String & | parameterLabel,
|  | Category | parameterCategory = AudioProcessorParameter::genericParameter,
|  | std::function< String(float value, int maximumStringLength)> | stringFromValue = nullptr,
|  | std::function< float(const String &text)> | valueFromString = nullptr )

inline

Creates a AudioParameterFloat with the specified parameters.

Parameters

  parameterID | The parameter ID to use
  parameterName | The parameter name to use
  normalisableRange | The NormalisableRange to use
  defaultValue | The non-normalised default value
  parameterLabel | An optional label for the parameter's value
  parameterCategory | An optional parameter category
  stringFromValue | An optional lambda function that converts a non-normalised value to a string with a maximum length. This may be used by hosts to display the parameter's value.
  valueFromString | An optional lambda function that parses a string and converts it into a non-normalised value. Some hosts use this to allow users to type in parameter values.

References AudioParameterFloat(), and juce::AudioProcessorParameter::genericParameter.

## AudioParameterFloat() [3/3]

juce::AudioParameterFloat::AudioParameterFloat | ( | const ParameterID & | parameterID,
|  | const String & | parameterName,
|  | float | minValue,
|  | float | maxValue,
|  | float | defaultValue )

Creates a AudioParameterFloat with an ID, name, and range.

On creation, its value is set to the default value. For control over skew factors, you can use the other constructor and provide a NormalisableRange.

## ~AudioParameterFloat()

juce::AudioParameterFloat::~AudioParameterFloat | ( |  | ) |

override

Destructor.

## Member Functions

## get()

float juce::AudioParameterFloat::get | ( |  | ) | const

inline noexcept

Returns the parameter's current value.

## operator float()

juce::AudioParameterFloat::operator float | ( |  | ) | const

inline noexcept

Returns the parameter's current value.

## operator=()

AudioParameterFloat & juce::AudioParameterFloat::operator= | ( | float | newValue | ) |

Changes the parameter's current value.

References AudioParameterFloat().

## getNormalisableRange()

const NormalisableRange< float > & juce::AudioParameterFloat::getNormalisableRange | ( |  | ) | const

inline override virtual

Returns the range of values that the parameter can take.

Implements juce::RangedAudioParameter.

References range.

## valueChanged()

virtual void juce::AudioParameterFloat::valueChanged | ( | float | newValue | ) |

protected virtual

Override this method if you are interested in receiving callbacks when the parameter value changes.

References AudioParameterFloat().

## Member Data Documentation

## range

NormalisableRange<float> juce::AudioParameterFloat::range

Provides access to the parameter's range.

Referenced by getNormalisableRange().

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited